// cWiatr.cpp: implementation of the cWiatr class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ble.h"
#include "cWiatr.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

cWiatr::cWiatr()
{
	this->Kat=0;
	this->Sila=0;
}

cWiatr::~cWiatr()
{

}

int cWiatr::zmienParametry(int delKat, int delSila)
{
	this->Kat+=delKat;
//	if (this->Kat<0) this->Kat=0;
	this->Kat=(this->Kat)%360;
	this->Sila+=delSila;
	if (this->Sila<0) this->Sila=0;
	if (this->Sila>10) this->Sila=10;
	return 1;
}

int cWiatr::rysuj()
{
	float plus=0;
	GLfloat MAmbient[]= { 1/2, 1/2, 0, 1.0f }; 
	GLfloat MDiffuse[4]={ 1, 1, 0, 1.0f };
	glTranslatef(50, 20, 50);

	glRotatef((float)(this->Kat), 0, 1, 0);

	glMaterialfv(GL_FRONT, GL_AMBIENT, MAmbient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, MDiffuse);


	glColor3f(0.6f, 0.6f, 0.0f);

	for (int q=0; q<((this->Sila)/2)+((this->Sila)%2); q++)
	{

	glBegin(GL_TRIANGLES); 
	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(0, 0, 1+plus);
	glVertex3f(-2, 0, -2+plus);
	glVertex3f(0, 0, plus);
	
	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(0, 0, 1+plus);
	glVertex3f(2, 0, -2+plus);
	glVertex3f(0, 0, plus);

	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(0, 2, 1+plus);
	glVertex3f(-2, 2, -2+plus);
	glVertex3f(0, 2, plus);

	glNormal3f(0.0,1.0,0.0); 
	glVertex3f(0, 2, 1+plus);
	glVertex3f(2, 2, -2+plus);
	glVertex3f(0, 2, plus);
	glEnd();

	glBegin(GL_QUADS); 
	glNormal3f(-1.0,0.0,0.0); 
	glVertex3f(-2, 0, -2+plus);
	glVertex3f(-2, 2, -2+plus);
	glVertex3f(0, 2, 1+plus);
	glVertex3f(0, 0, 1+plus);	
	
	glNormal3f(1.0,0.0,0.0); 
	glVertex3f(2, 0, -2+plus);
	glVertex3f(2, 2, -2+plus);
	glVertex3f(0, 2, 1+plus);
	glVertex3f(0, 0, 1+plus);	
	
	glNormal3f(-1.0,0.0,0.0); 
	glVertex3f(0, 0, plus);
	glVertex3f(0, 2, plus);
	glVertex3f(-2, 2, -2+plus);
	glVertex3f(-2, 0, -2+plus);	
	
	glNormal3f(1.0,0.0,0.0); 
	glVertex3f(0, 0, plus);
	glVertex3f(0, 2, plus);
	glVertex3f(2, 2, -2+plus);
	glVertex3f(2, 0, -2+plus);	
	glEnd();

	plus+=2;
	};
	glRotatef(-(float)(this->Kat), 0, 1, 0);
	glTranslatef(-50, -20, -50);
	return 1;
}

int cWiatr::zmianaWiatru()
{
	int delK, delS;
	delK=(rand()%3)-1;
	delS=(rand()%3)-1;
	this->zmienParametry(delK*5, delS); 	
	return 1;
}
